package cn.com.qmth.dp.examcloud.oe.entity.marking;

import java.util.HashSet;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.EnumType;
import javax.persistence.Enumerated;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.validation.constraints.NotNull;

import cn.com.qmth.dp.examcloud.oe.enums.marking.MarkModeType;


/**
 * update by nikang on 2018/09/23.
 */
@Entity
@Table(name = "ec_m_mark_range",indexes = {
		@Index(name = "IDX_M_MARK_RANGE_01", columnList = "basePaperId,workId", unique = true)})
public class MarkRangeEntity extends IdEntity {


    private static final long serialVersionUID = -1475233351987693246L;

    @NotNull
    private String basePaperId;

    @NotNull
    private Long workId;
    /**
     * 基础试卷名称
     */
    private String name;

    @Enumerated(value = EnumType.STRING)
    private MarkModeType markMode;

    @OneToMany(cascade = CascadeType.REFRESH)
    @JoinColumn(name = "markRangeId")
    private Set<MarkItemEntity> markItems = new HashSet<>();


    public MarkRangeEntity(){}


    @NotNull
    public String getBasePaperId() {
        return basePaperId;
    }

    public void setBasePaperId(@NotNull String basePaperId) {
        this.basePaperId = basePaperId;
    }

    public MarkModeType getMarkMode() {
        return markMode;
    }

    public void setMarkMode(MarkModeType markMode) {
        this.markMode = markMode;
    }

    public Set<MarkItemEntity> getMarkItems() {
        return markItems;
    }

    public void setMarkItems(Set<MarkItemEntity> markItems) {
        this.markItems = markItems;
    }


	public Long getWorkId() {
		return workId;
	}

	public void setWorkId(Long workId) {
		this.workId = workId;
	}

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
